'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3Timer = require('d3-timer');

var _d3Shape = require('d3-shape');

var _d3Ease = require('d3-ease');

var ease = _interopRequireWildcard(_d3Ease);

var _d3Selection = require('d3-selection');

var _d3Scale = require('d3-scale');

var _d3Interpolate = require('d3-interpolate');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * PropType for fill and stroke..
 */
var fillStroke = _react.PropTypes.shape({
    fill: _react.PropTypes.string,
    stroke: _react.PropTypes.string
});

var LiquidFillGauge = (_temp = _class = function (_Component) {
    _inherits(LiquidFillGauge, _Component);

    function LiquidFillGauge() {
        _classCallCheck(this, LiquidFillGauge);

        return _possibleConstructorReturn(this, (LiquidFillGauge.__proto__ || Object.getPrototypeOf(LiquidFillGauge)).apply(this, arguments));
    }

    _createClass(LiquidFillGauge, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.animate) {
                this.animate();
                return;
            }
            this.draw();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.props.animate) {
                this.animate();
                return;
            }
            this.draw();
        }
    }, {
        key: 'setRes',
        value: function setRes() {
            var width = this.props.width * this.props.innerRadius / 2;
            var height = this.props.height * (this.props.innerRadius - this.props.margin) / 2;

            this.arr = new Array(100);
            this.wave = (0, _d3Selection.select)(this.clipPath).datum([this.props.value]);
            this.text = (0, _d3Selection.select)(this.container).selectAll('text').selectAll('tspan.value');
            this.x = (0, _d3Scale.scaleLinear)().range([-width, width]).domain([0, 100]);
            this.y = (0, _d3Scale.scaleLinear)().range([height, -height]).domain([0, 100]);
        }
    }, {
        key: 'draw',
        value: function draw() {
            var _this2 = this;

            this.setRes();

            var val = (0, _d3Shape.area)().x(function (d, i) {
                return _this2.x(i);
            }).y0(function (d, i) {
                return _this2.y(_this2.props.amplitude * Math.sin(i / 4) + _this2.props.value);
            }).y1(function (d) {
                return _this2.props.height / 2;
            });

            this.wave.attr('d', val(this.arr));
            this.text.text(Math.round(this.props.value));
        }
    }, {
        key: 'animate',
        value: function animate() {
            var _this3 = this;

            this.setRes();

            var val = (0, _d3Shape.area)().x(function (d, i) {
                return _this3.x(i);
            }).y0(function (d, i) {
                return _this3.y(Math.sin(i / 4));
            }).y1(function (d) {
                return _this3.props.height / 2;
            });
            var time = (0, _d3Scale.scaleLinear)().range([0, 1]).domain([0, this.props.animationTime]);
            var interpolateValue = (0, _d3Interpolate.interpolate)(this.wave.node().old || 0, this.props.value);
            var _props = this.props,
                onAnimationProgress = _props.onAnimationProgress,
                onAnimationEnd = _props.onAnimationEnd;

            var animationTimer = (0, _d3Timer.timer)(function (t) {
                var animate = _this3.props.ease(time(t));

                val.y0(function (d, i) {
                    return _this3.y(_this3.props.amplitude * Math.sin(i / _this3.props.frequency) + interpolateValue(animate));
                });

                var value = Math.round(interpolateValue(animate));
                _this3.text.text(value);
                onAnimationProgress({
                    value: value,
                    outerArc: (0, _d3Selection.select)(_this3.container).select('.outerArc'),
                    liquid: (0, _d3Selection.select)(_this3.container).select('.liquid'),
                    liquidNumber: (0, _d3Selection.select)(_this3.container).select('.liquidNumber'),
                    number: (0, _d3Selection.select)(_this3.container).select('.number')
                });

                _this3.wave.attr('d', val(_this3.arr));

                if (t > _this3.props.animationTime) {
                    animationTimer.stop();
                    var _value = Math.round(_this3.props.value);
                    _this3.text.text(_value);
                    onAnimationEnd({
                        value: _value,
                        outerArc: (0, _d3Selection.select)(_this3.container).select('.outerArc'),
                        liquid: (0, _d3Selection.select)(_this3.container).select('.liquid'),
                        liquidNumber: (0, _d3Selection.select)(_this3.container).select('.liquidNumber'),
                        number: (0, _d3Selection.select)(_this3.container).select('.number')
                    });
                }
            });

            this.wave.node().old = this.props.value;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var style = this.props.style;

            var radius = Math.min(this.props.height / 2, this.props.width / 2);
            var liquidRadius = radius * (this.props.innerRadius - this.props.margin);
            var outerArc = (0, _d3Shape.arc)().outerRadius(this.props.outerRadius * radius).innerRadius(this.props.innerRadius * radius).startAngle(0).endAngle(Math.PI * 2);
            var cX = this.props.width * this.props.offsetX / 2;
            var cY = this.props.height * this.props.offsetY / 2;
            var textPixels = this.props.textSize * radius / 2;

            return _react2.default.createElement(
                'div',
                {
                    style: _extends({
                        width: this.props.width,
                        height: this.props.height
                    }, style)
                },
                _react2.default.createElement(
                    'svg',
                    { width: '100%', height: '100%' },
                    _react2.default.createElement(
                        'g',
                        {
                            ref: function ref(c) {
                                _this4.container = c;
                            },
                            transform: 'translate(' + cX + ',' + cY + ')'
                        },
                        _react2.default.createElement(
                            'defs',
                            null,
                            _react2.default.createElement(
                                'clipPath',
                                { id: 'clip' },
                                _react2.default.createElement('path', {
                                    ref: function ref(c) {
                                        _this4.clipPath = c;
                                    }
                                })
                            )
                        ),
                        _react2.default.createElement(
                            'text',
                            {
                                className: 'number',
                                style: {
                                    textAnchor: 'middle',
                                    fontSize: textPixels + 'px'
                                },
                                fill: this.props.numberStyle.fill,
                                stroke: this.props.numberStyle.stroke,
                                transform: 'translate(' + this.props.textOffsetX + ',' + this.props.textOffsetY + ')'
                            },
                            _react2.default.createElement(
                                'tspan',
                                { className: 'value' },
                                this.props.value
                            ),
                            _react2.default.createElement(
                                'tspan',
                                null,
                                this.props.percentageSymbol
                            )
                        ),
                        _react2.default.createElement(
                            'g',
                            { clipPath: 'url(#clip)' },
                            _react2.default.createElement('circle', {
                                className: 'liquid',
                                r: liquidRadius,
                                fill: this.props.liquidStyle.fill
                            }),
                            _react2.default.createElement(
                                'text',
                                {
                                    className: 'liquidNumber',
                                    style: {
                                        textAnchor: 'middle',
                                        fontSize: textPixels + 'px'
                                    },
                                    fill: this.props.liquidNumberStyle.fill,
                                    stroke: this.props.liquidNumberStyle.stroke,
                                    transform: 'translate(' + this.props.textOffsetX + ',' + this.props.textOffsetY + ')'
                                },
                                _react2.default.createElement(
                                    'tspan',
                                    { className: 'value' },
                                    this.props.value
                                ),
                                _react2.default.createElement(
                                    'tspan',
                                    null,
                                    this.props.percentageSymbol
                                )
                            )
                        ),
                        _react2.default.createElement('path', {
                            className: 'outerArc',
                            d: outerArc(),
                            fill: this.props.outerArcStyle.fill,
                            stroke: this.props.outerArcStyle.stroke
                        }),
                        _react2.default.createElement('circle', {
                            r: radius,
                            fill: 'rgba(0, 0, 0, 0)',
                            stroke: 'rgba(0, 0, 0, 0)',
                            style: { pointerEvents: 'all' },
                            onClick: function onClick() {
                                _this4.props.onClick();
                            }
                        })
                    )
                )
            );
        }
    }]);

    return LiquidFillGauge;
}(_react.Component), _class.propTypes = {
    // a percentage from 0 to 100
    value: _react.PropTypes.number,
    // boolean if true then animate
    animate: _react.PropTypes.bool,
    // callback function called when animation is in progress
    onAnimationProgress: _react.PropTypes.func,
    // callback function called when animation is done
    onAnimationEnd: _react.PropTypes.func,
    onClick: _react.PropTypes.func,
    // comes from Chart parent
    width: _react.PropTypes.number,
    // comes from Chart parent
    height: _react.PropTypes.number,
    // innerRadius
    innerRadius: _react.PropTypes.number,
    // outer radius
    outerRadius: _react.PropTypes.number,
    // margin between inner liquid and innerRadius
    margin: _react.PropTypes.number,
    // d3 easing functions
    ease: _react.PropTypes.func,
    // animation Time
    animationTime: _react.PropTypes.number,
    // the wave amplitude
    amplitude: _react.PropTypes.number,
    // the wave frequency inverse, the higer the number the fewer the waves
    frequency: _react.PropTypes.number,
    // on click
    // The fill and stroke for the outer arc
    outerArcStyle: fillStroke,
    // The fill and stroke for the liquid
    liquidStyle: fillStroke,
    // The fill and stroke for the number part that is drenched in liquid
    liquidNumberStyle: fillStroke,
    // the fill and stroke of the number that is not drenched in liquid
    numberStyle: fillStroke,
    offsetY: _react.PropTypes.number,
    offsetX: _react.PropTypes.number,
    // The relative height of the text to display in the wave circle. 1 = 50%
    textSize: _react.PropTypes.number,
    textOffsetX: _react.PropTypes.number,
    textOffsetY: _react.PropTypes.number,
    percentageSymbol: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool])
}, _class.defaultProps = {
    value: 100,
    animate: false,
    onAnimationProgress: function onAnimationProgress() {},
    onAnimationEnd: function onAnimationEnd() {},
    onClick: function onClick() {},
    outerRadius: 1.0,
    innerRadius: 0.9,
    margin: 0.025,
    ease: ease.easeCubicInOut,
    animationTime: 2000,
    amplitude: 1,
    frequency: 5,
    outerArcStyle: {
        fill: 'rgb(23, 139, 202)'
    },
    liquidStyle: {
        fill: 'rgb(23, 139, 202)'
    },
    liquidNumberStyle: {
        fill: 'rgb(164, 219, 248)'
    },
    numberStyle: {
        fill: 'rgb(4, 86, 129)'
    },
    offsetX: 1,
    offsetY: 1,
    textSize: 1,
    textOffsetX: 0,
    textOffsetY: 0,
    percentageSymbol: '%'
}, _temp);


module.exports = LiquidFillGauge;